/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante.asistencia;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.ExNihilo;
import logica.Search;
import orm.Asistencia;
import orm.Estudiante;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "EliminarAsistencia", urlPatterns = {"/EliminarAsistencia"})
public class EliminarAsistencia extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try {
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
            String fechaString = request.getParameter("fecha");
            String asistioString = request.getParameter("asistio");
            String estudianteRut = request.getParameter("estudianteEliminar");
            if (!fechaString.equals("")) {
                if (!asistioString.equals("")) {
                    if (!estudianteRut.equals("")) {
                        Date fecha = format.parse(fechaString);
                        boolean asistio = asistioString.equals("si");
                        Estudiante estudiante = Search.buscarEstudiante(estudianteRut);
                        if (fecha != null) {
                            if (estudiante != null) {
                                Asistencia asistencia = Search.buscarAsistencia(estudiante, fecha, asistio);
                                if (asistencia != null) {
                                    if (ExNihilo.eliminarAsistencia(asistencia)) {
                                        request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                                    } else {
                                        request.setAttribute("errorEliminar", "A ocurrido un error innesperado");
                                        request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                                    }
                                } else {
                                    request.setAttribute("errorEliminar", "La asistencia no existe");
                                    request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                                }
                            } else {
                                request.setAttribute("errorEliminar", "El estudiante no existe");
                                request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                            }
                        } else {
                            request.setAttribute("errorEliminar", "La fecha es erronea");
                            request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                        }
                    } else {
                        request.setAttribute("errorEliminar", "No hay estudiante seleccionado");
                        request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                    }

                } else {
                    request.setAttribute("errorEliminar", "No hay asistencia seleccionada");
                    request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
                }
            } else {
                request.setAttribute("errorEliminar", "No hay fecha seleccionada");
                request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
            }
        } catch (ParseException ex) {
            Logger.getLogger(CrearAsistencia.class.getName()).log(Level.SEVERE, null, ex);
            request.setAttribute("errorEliminar", "La fecha ingresada es erronea");
            request.getRequestDispatcher("AsistenciasServlet").forward(request, response);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
